/* DPMI.CPP:
*/


#include <stdio.h>     // printf()
#include <stdlib.h>    // exit()
#include "dpmi.h"

//--------------------------------------------------------------
DPMI_ERROR DPMI_ErrorArray[] =
 {{ 0x0007,"Memory control block damaged"},
  { 0x0008,"Insufficient memory"},
  { 0x0009,"Incorrect memory segment specified"},
  { 0x8001,"Unsupported function invoked"},
  { 0x8002,"Invalid state for an object"},
  { 0x8003,"Operation would compromise system integrity"},
  { 0x8004,"Host detected a deadlock situation"},
  { 0x8005,"Pending serialization request cancelled"},
  { 0x8010,"Cannot allocate resource"},
  { 0x8011,"Out of descriptors"},
  { 0x8012,"No available linear memory"},
  { 0x8013,"No available physical memory"},
  { 0x8014,"Backing store unavilable"},
  { 0x8015,"Unable to allocate callback address"},
  { 0x8016,"Unable to allocate handle"},
  { 0x8017,"Host's locking count exceeded"},
  { 0x8018,"Memory block exclusively owned by another client"},
  { 0x8019,"Memory block shared with another client"},
  { 0x8021,"Numeric/flag parameter has invalid value"},
  { 0x8022,"Selector doesn't correspond to valid descriptor"},
  { 0x8023,"Invalid handle parameter"},
  { 0x8024,"Invalid callback paramter"},
  { 0x8025,"Invalid linear address range"},
  { 0x8026,"Hardware does not support request"},
  { 0x0000,"Unexpected error code"}};


//--------------------------------------------------------------
void fail(const char *errMsg, unsigned short code) {
  int i = 0;

  if (!code) return;

  if (*errMsg) printf("\n%s", errMsg);

  while(DPMI_ErrorArray[i].error_code != 0 &&
        DPMI_ErrorArray[i].error_code != code) i++;

  if (DPMI_ErrorArray[i].error_code)
    printf("\n%s (0x%X)", DPMI_ErrorArray[i].error_msg, code);
  else
    printf("Unexpected error code 0x%X", code);

  exit(1);
} // end of fail()

#if defined (DPMI_MAIN)
//**************************************************************
void main(void) {
  fail("Testing error handler", 0x8011);
} // end of main()

#endif // DPMI_MAIN
