/* PHARLAP.H: Phar Lap Emulator structures/prototypes/constants
*/

#if !defined (PHARLAP_H)
#define PHARLAP_H

typedef void VOID;
typedef VOID _far *PVOID;
typedef unsigned char BYTE;
typedef short SHORT;
typedef unsigned short USHORT;
typedef USHORT _far *PUSHORT;
typedef unsigned long ULONG;
typedef ULONG *PULONG;
typedef unsigned short SEL;
typedef SEL _far *PSEL;

#define APIENTRY pascal _far
#define MAKEP(sel, off) ((PVOID)((((ULONG)(sel))<<16)+(off)))
#define PHARLAP_NOTENOUGHMEMORY 8
#define SELECTOROF(fp) ((SEL)(((ULONG)(fp)) >> 16))
#define OFFSETOF(fp) ((UINT)(ULONG)(fp))

// Far Lap register structure
typedef struct {
  USHORT es, ds;
  USHORT di, si, bp, sp, bx, dx, cx, ax;  // PUSHA
  USHORT ip, cs, flags;
} REGS16, far *PREGS;

USHORT APIENTRY DosAllocRealSeg(ULONG size, PUSHORT ppara,
                                PSEL psel);
USHORT APIENTRY DosFreeSeg(USHORT sel);
USHORT _far _cdecl DosRealIntr(USHORT intno, PREGS pregs,
                               ULONG reserved, USHORT words, ...);
USHORT APIENTRY DosMemAvail(PULONG pavail);
USHORT APIENTRY DosCreateCSAlias(SEL datasel, PSEL pcodesel);


// Non-Phar Lap helper functions
USHORT APIENTRY CreateAlias(PSEL dataSel, PSEL codeSel);

#endif // PHARLAP_H

